#include <HT32F125x.h>

// Key1	PB11
// D5	PB12
// Bit-band alias = Bit-band base + (byte offset * 32) + (bit number * 4)
/* Bit-Band for Device Specific Peripheral Registers */
#define BITBAND_PERI(addr, bitnum) (HT_PERIPH_BB_BASE + (((uint32_t)(addr) - HT_PERIPH_BASE) << 5) + ((uint32_t)(bitnum) << 2))

#define KEY1 (*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DINR,11)))
#define D5 (*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DOUTR,12)))

main()
{
	HT_CKCU->APBCCR0 |= (1<<17);		// 17=PBEN, enable APB clocks for GPIOB
	HT_GPIOB->DIRCR &= ~(1<<11);		// PB11 defined as Input
	HT_GPIOB->INER |= (1<<11);		// PB11 input circuit enabled
	HT_GPIOB->DIRCR |= (1<<12);		// PB12 defined as Output
	HT_GPIOB->DOUTR |= (1<<12);		// PB12=1, LED off
	while(1){
		if(KEY1)		// read PB11 (Key1)
			D5 = 1;		// write PB12=1, LED off
		else
			D5 = 0;		// write PB12=0, LED on
	}
}
